var _webdomain = "";
var _configdomain = "";

var web = null;

// vue的method里编写如下代码
function requestAndroidPermissionFun(permisionID) {
    var result = requestAndroidPermission(permisionID)
    var strStatus
    if (result == 1) {
        strStatus = "已获得授权"
    } else if (result == 0) {
        strStatus = "未获得授权"
    } else {
        strStatus = "被永久拒绝权限"
    }
    uni.showModal({
        content: permisionID + strStatus,
        showCancel: false
    });
}

/**
 * index 初始化
 */
function plusReady() {
    window.localStorage.removeItem("errorretry");
    _webdomain = appdata.webdomain;
    _configdomain = appdata.configdomain;
    Update();
}

function SaveInputCode() {
    var inputcode = document.getElementById("inputcode").value;
    if (inputcode != undefined && inputcode != "") {
		try{
			//加密解密
			//inputcode=Decrypt(inputcode);
			
			var xhr = new XMLHttpRequest();
			xhr.timeout = 5000;
			xhr.onreadystatechange = function () {
			    alert(xhr.readyState + xhr.status);
			    switch (xhr.readyState) {
			        case 4:
			            var isok = false;
			            if (xhr.status == 200) {
			                isok = (xhr.responseText == appdata.key);
			            }
			            if (!isok) {
			                alert("无效代码");
			                return;
			            }
			            window.localStorage.setItem("configdomain", inputcode);
			            plus.runtime.restart();//重启app
			            break;
			        default:
			            break;
			    }
			}
            xhr.open("GET", inputcode + appdata.keycheck + "?v" + (new Date()).getTime().toString());
			xhr.send();
		}
		catch(e){
			  alert("发生异常"+e);
		}
    }
}

function HideInputCode() {
    document.getElementById("maskbox-inputcode").style.display = "none";
}
function ShowInputCode() {
    document.getElementById("maskbox-inputcode").style.display = "block";
}
/**
 * 检查更新
 */
function Update() {
    AddLog("Updata");
    // 在流应用模式下不需要检测升级操作
    if (!navigator.userAgent.indexOf('StreamApp') >= 0) {
        var configdomain = window.localStorage.getItem("configdomain");
        if (configdomain != null) {
            _configdomain = configdomain;
            AddLog("configdomain" + _configdomain + "来自缓存");
        }
        getUpdateData(0);
    }
}

/**
 * 检查升级数据
 */
function checkUpdateData(j) {
    var curVer = plus.runtime.version,
        inf = j[plus.os.name];
    if (inf) {
        var srvVer = inf.version;
        AddLog("当前/线上版本：" + curVer + "/" + srvVer);
        // 判断是否需要升级
        if (compareVersion(curVer, srvVer)) {
            // 提示用户是否升级
            plus.nativeUI.confirm(inf.note, function (i) {
                if (0 == i.index) {
                    plus.runtime.openURL(inf.url);
                    plus.runtime.quit();//取消更新退出app
                }
                else {
                    plus.runtime.quit();//取消更新退出app
                }
            }, inf.title, ["立即更新"]);
        }
        else {
            LoadWeb();
        }
    }
}

/**
 * 从服务器获取升级数据
 */
function getUpdateData(index) {
    if (index < appdata.updateconfig.length) {
        var server = _configdomain + appdata.updateconfig[index];
        var xhr = new XMLHttpRequest();
        xhr.timeout = 5000;
        xhr.onreadystatechange = function () {
            switch (xhr.readyState) {
                case 4:
                    var isok = false;
                    if (xhr.status == 200) {
                        try {
                            var data = JSON.parse(xhr.responseText);
                            AddLog("更新json获取：" + (index + 1) + "/" + appdata.updateconfig.length + "，" + server + "【成功】");
                            AddLog("更新json内容：" + xhr.responseText);
                            checkUpdateData(data);
                            isok = true;
                            return;
                        } catch (e) {
                            alert(e);
                        }
                    }

                    if (!isok) {
                        AddLog("更新json获取：" + (index + 1) + "/" + appdata.updateconfig.length + "，" + server + "【失败】");
                        getUpdateData(index + 1);
                    }
                    break;
                default:
                    break;
            }
        }
        xhr.open("GET", server + "?v" + (new Date()).getTime().toString());
        xhr.send();
    }
    else {
        LoadWeb();
    }
}

/**
 * 比较版本大小，如果新版本nv大于旧版本ov则返回true，否则返回false
 * @param {String} ov
 * @param {String} nv
 * @return {Boolean} 
 */
function compareVersion(ov, nv) {
    if (!ov || !nv || ov == "" || nv == "") {
        return false;
    }
    var b = false,
        ova = ov.split(".", 4),
        nva = nv.split(".", 4);
    for (var i = 0; i < ova.length && i < nva.length; i++) {
        var so = ova[i], no = parseInt(so), sn = nva[i], nn = parseInt(sn);
        if (nn > no || sn.length > so.length) {
            return true;
        } else if (nn < no) {
            return false;
        }
    }
    if (nva.length > ova.length && 0 == nv.indexOf(ov)) {
        return true;
    }
}


/**
 * 加载Web
 */
function LoadWeb() {
    ShowProgressInfo("加载中，请稍后……");
    //从缓存中获取域名
    var domain = appdata.webdomain;
    var webdomain = window.localStorage.getItem("webdomain");
    if (webdomain != null) {
        domain = webdomain;
        AddLog(domain + "来自缓存");
    }
    GetDomain(-1, domain);
}

/**
 * 校验域名是否正常
 */
function CheckDomainIsOK(index, domain, callback) {
	LoadDomain(domain);
    // var url = domain + "/appcheck.html?v" + new Date().getTime().toString();
    // var xhr = new XMLHttpRequest();
    // xhr.timeout = 5000;
    // xhr.onreadystatechange = function () {
    //     AddLog(xhr.readyState + "-" + xhr.status);
    //     switch (xhr.readyState) {
    //         case 4:
    //             var isok = false;
    //             if (xhr.status == 200) {
    //                 isok = xhr.responseText == "ok";
    //             }
    //             AddLog(index + "域名" + domain + "校验结果：" + (isok ? "可用" : "不可用"));
    //             if (isok) {
    //                 LoadDomain(domain);
    //             }
    //             else {
    //                 callback(index, "");
    //             }
    //             break;
    //         default:
    //             break;
    //     }
    // }
    // xhr.open("GET", url + "?v" + (new Date()).getTime().toString());
    // xhr.send();
}

/**
 * 从服务器获取动态域名
 */
function GetDomain(index, domain) {
    if (domain != "") {
        CheckDomainIsOK(index + 1, domain, GetDomain);
        return;
    }
    if (index < appdata.sitenameconfig.length) {
        var host = _configdomain + appdata.sitenameconfig[index];
        try {
            var xhr = new XMLHttpRequest();
            xhr.timeout = 5000;
            xhr.onreadystatechange = function () {
                switch (xhr.readyState) {
                    case 4:
                        var isok = false;
                        var tempdomain = "";
                        if (xhr.status == 200) {
                            tempdomain = xhr.responseText;
                            isok = tempdomain.match(/^(http(s)?:\/\/)(((www\.)?[a-zA-Z0-9][-a-zA-Z0-9]{0,62}(\.[a-zA-Z0-9][-a-zA-Z0-9]{0,62})+)|(((25[0-5])|(2[0-4]\d)|(1\d\d)|([1-9]\d)|\d)(\.((25[0-5])|(2[0-4]\d)|(1\d\d)|([1-9]\d)|\d)){3}))(:\d+)*(\/\w+\.?\w+)*(\/)?$/g);
                        }
                        AddLog("检查sitenamehost:" + (index + 1) + "/" + appdata.sitenameconfig.length + ":" + host + "【" + (isok ? "成功" : "失败") + "】");
                        if (!isok) {
                            GetDomain(index + 1, "");
                        }
                        else {
                            AddLog("获取到host:" + tempdomain);
                            CheckDomainIsOK(index + 1, tempdomain, GetDomain);
                        }
                        break;
                    default:
                        break;
                }
            }
            xhr.open("GET", host + "?v" + (new Date()).getTime().toString());
            xhr.send();
        }
        catch (e) {
            alert(e);
        }
    }
    else {
        ShowProgressInfo("很抱歉，加载失败！请关闭APP重试！");
        document.getElementById("btn-inputcode").style.display = "inline-block";
    }
}
/**
 * 加载appweb对象
 */
function LoadDomain(domain) {
    AddLog("加载：" + domain);
    //保存缓存
    window.localStorage.setItem("webdomain", domain);
    web = plus.webview.create(domain + "?v" + new Date().getTime().toString(), 'hjhsub', { top: '0px', bottom: '0px' });
    plus.webview.currentWebview().append(web);
    web.appendJsFile('js/mui.js');
    web.appendJsFile('js/downloadImage.js');
    web.show();

    // 关闭启动界面
    plus.navigator.setStatusBarBackground('#D74B28');
    setTimeout(function () {
        plus.navigator.closeSplashscreen();
    }, 200);
	
	// requestAndroidPermissionFun('camera');
}

/**
 * 显示进度
 */
function ShowProgressInfo(infostr) {
    document.getElementById("progressinfo").innerHTML = infostr;
}
